#include <stdlib.h>
#include <stdio.h>
#ifdef __APPLE__
#include <GLUT/glut.h>
#else
#include <GL/glut.h>
#endif
#include <math.h>

int width, height;
int xmin, ymin;
float L[2];
float theta[2];
float beginPoint[2]; 
float pos = 1;


void drawObject()
{
  int i;

  glPointSize(8.0);
  glLineWidth(5.0);

  glPushMatrix();
  glTranslatef(0, -0.9, 0);
  /* Le sol */
  glColor3f(1.0, 0.0, 0.0);
  glBegin(GL_LINES);
  glVertex2f(-1.0, 0.0);
  glVertex2f(1.0, 0.0);
  glEnd();

  glRotatef(-90.0, 0, 0, 1);
  glBegin(GL_POINTS);
  glVertex2f(0.0, 0.0);
  glEnd();
  
  glColor3f(0.0, 1.0, 0.0);
  glRotatef(theta[0], 0, 0, 1);
  glBegin(GL_LINES);
  glVertex2f(0.0, 0.0);
  glVertex2f(0.0, L[0]);
  glEnd();

  glColor3f(1.0, 0.0, 0.0);
  glTranslatef(0.0, L[0], 0.0);
  glBegin(GL_POINTS);
  glVertex2f(0.0, 0.0);
  glEnd();
  
  glColor3f(0.0, 0.0, 1.0);
  glRotatef(theta[1], 0, 0, 1);
  glBegin(GL_LINES);
  glVertex2f(0.0, 0.0);
  glVertex2f(0.0, L[1]);
  glEnd();

  glColor3f(1.0, 0.0, 0.0);
  glTranslatef(0.0, L[1], 0.0);
  glBegin(GL_POINTS);
  glVertex2f(0.0, 0.0);
  glEnd();

  glPopMatrix();
}

void
mouse(int button, int state, int x, int y)
{
  float d;
  float cos_t;
  float xp, yp;
  
  if (state == GLUT_DOWN) {
    xp = -1 + (2.0*(x-xmin))/(float)height;
    yp = 1.9 - (2.0*(y-ymin))/(float)height;
    /* Coordonnes du point ou on a clique sur l'ecran, par rapport au point de dpart du bras articul */

    /* C'est ici qu'il y a plein de choses a ecrire */

    
    /* Conversion des angles en degres pour glRotate  */
    theta[0] *= 180.0/M_PI;
    theta[1] *= 180.0/M_PI;
  } 
  glutPostRedisplay();
}

void
motion(int x, int y)
{
  float d;
  float cos_t;
  float xp, yp;
  
  xp = -1 + (2.0*(x-xmin))/(float)height;
  yp = 1.9 - (2.0*(y-ymin))/(float)height;
  /* Coordonnes du point ou on a clique sur l'ecran, par rapport au point de dpart du bras articul */
  
  /* C'est ici qu'il y a plein de choses a ecrire */
  
  
  /* Conversion des angles en degres pour glRotate  */
  theta[0] *= 180.0/M_PI;
  theta[1] *= 180.0/M_PI;
  glutPostRedisplay();
}

void printHelp()
{
  printf("A small program to show two-link Inverse Kinematics\n\n");
}

void parsekey(unsigned char key, int x, int y)
{
  switch (key)
    {
    case 27: exit(0);
    case ' ':
      break;
    case 'h':
      printHelp();
      break;
    default:
      return;
    }
  glutPostRedisplay();
}

void parsekey_special(int key, int x, int y)
{
  switch (key)
    {
    case GLUT_KEY_UP:	
      break;
    case GLUT_KEY_DOWN:	
      break;
    case GLUT_KEY_RIGHT: 
      break;
    case GLUT_KEY_LEFT:	 
      break;
    default:
      return;
    }
  glutPostRedisplay();
}

void myReshape(int w, int h)
{
  xmin = 0;
  ymin = 0;
  if (w > h) {
    xmin = (w-h)/2;
    w = h;
  } else {
    ymin = (h-w)/2;
    h = w;
  }
  width = w;
  height = h;
  glViewport(xmin, ymin, w, h);
  glutPostRedisplay();
}

void display(void)
{
  glPushMatrix();
  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT | GL_STENCIL_BUFFER_BIT);

  drawObject();

  glutSwapBuffers();
  glPopMatrix();
}

void myinit(void)
{
  glLoadIdentity();
  glClearColor(0.0, 0.0, 0.1, 1.0);
  L[0] = 0.6;
  L[1] = 0.4;
  theta[0] = 0.0;
  theta[1] = 0.0;
}

int main(int argc, char *argv[]) 
{
  glutInit(&argc, argv);
  glutInitDisplayMode(GLUT_DEPTH | GLUT_RGB | GLUT_DOUBLE | GLUT_MULTISAMPLE |
		      GLUT_STENCIL);
  glutCreateWindow("Inverse Kinematics, level 2");
  glutDisplayFunc(display);
  glutInitWindowSize(1200, 1200);
  glutInitWindowPosition(200, 0);
  glutMouseFunc(mouse);
  glutMotionFunc(motion);
  glutKeyboardFunc(parsekey);
  glutSpecialFunc(parsekey_special);
  glutReshapeFunc(myReshape);
  myinit();
  printHelp();
    
  glutSwapBuffers();
  glutMainLoop();
  return 0;
}
